-- don't edit these
dofile_once( "data/scripts/lib/coroutines.lua" );
dofile_once( "mods/ui_timer_hits/files/lib/variables.lua" );
dofile_once( "mods/ui_timer_hits/files/config.lua" );

local gui = gui or GuiCreate();
local gui_id = 23728;
local id_offset = 0;

function next_id()
    id_offset = id_offset + 1;
    return gui_id + id_offset;
end

function do_gui()
    local text = "";
    local player = (EntityGetWithTag( "player_unit" ) or {})[1];
    if player ~= nil then
        local x, y = EntityGetTransform( player );
        id_offset = 0;

        local gx = GUI_X;
        local gy = GUI_Y;

        local inventory = EntityGetFirstComponent( player, "InventoryGuiComponent" );
        local is_inventory_open = false;
        if inventory ~= nil then
            if ComponentGetValue( inventory, "mActive" ) == "1" then
                is_inventory_open = true;
                gx = INVENTORY_GUI_X;
                gy = INVENTORY_GUI_Y;
            end
        end

        if SHOW_WHILE_IN_INVENTORY or not is_inventory_open then
            local entries = {};

            if SHOW_TIME then
                --if USE_GAME_FRAMES_FOR_TIMER then
                --    text = "Time: "..math.floor( GameGetFrameNum() / 60 ) .. " ";
                --end
                table.insert( entries, string.format( TIME_STRING, StatsGetValue( "playtime_str" ) ) );
            end
            if SHOW_HITS then
                local hit_count = EntityGetVariableNumber( player, "ui_timer_hits_total_hits", 0 );
                if hit_count == 1 then
                    table.insert( entries, string.format( HIT_STRING, hit_count ) );
                else
                    table.insert( entries, string.format( HITS_STRING, hit_count ) );
                end
            end
            if SHOW_DEPTH then
                table.insert( entries, string.format( DEPTH_STRING, math.floor( y / 10 ) ) );
            end

            for index,entry in ipairs( entries ) do
                text = text .. entry;
                if index ~= #entries then
                    text = text .. SEPARATOR;
                end
            end

            GuiStartFrame(gui);
            GuiLayoutBeginVertical( gui, gx, gy ); -- fold vertical
            GuiText( gui, 0, 0, text );
            GuiLayoutEnd( gui );
        end
    end
end

if gui then async_loop(function() if gui then do_gui() end wait(0); end); end
