dofile_once( "mods/ui_timer_hits/files/config.lua" );
dofile_once( "mods/ui_timer_hits/files/lib/variables.lua" );

last_sound_played = 0;

function damage_received( damage, message, entity_thats_responsible, is_fatal  )
    local entity = tonumber( GetUpdatedEntityID() );
    local counted_hit = false;
    if tonumber( entity_thats_responsible ) == 0 then
        if INCLUDE_ENVIRONMENTAL_HITS then counted_hit = true; end
    elseif tonumber( entity_thats_responsible ) == entity then
        if INCLUDE_SELF_DAMAGE_HITS then counted_hit = true; end
    else
        counted_hit = true;
    end
    if counted_hit then
        EntityAdjustVariableNumber( entity, "ui_timer_hits_total_hits", 0, function( value ) return tonumber( value ) + 1 end );
        if PLAY_SOUND_ON_HIT then
            local now = GameGetFrameNum();
            if now - last_sound_played >= TIME_BETWEEN_SOUNDS then
                last_sound_played = now;
                local x, y = EntityGetTransform( entity );
                for i=1,math.min( SOUND_VOLUME, 10 ) do
                    for _, sound in pairs( SOUNDS_TO_PLAY ) do
                        GamePlaySound( sound.bank, sound.event, x, y );
                    end
                end
            end
        end
        if SHOW_HIT_MESSAGE then
            GamePrint( string.format( HIT_MESSAGE_STRING, damage * 25 ) );
        end
    end
end
